program Mafija;
const MaxN = 100000; MaxPrejel = 1000000000;
var
  Nad, PrviPod, NaslPod, Utajil, Vrsta: array [1..MaxN] of integer;
  Prejel: array [1..MaxN] of int64;
  i, j, Znesek, n, Sef, Glava, Rep, MaxUtaja: integer; T: text;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'mafija.in');
  Reset(T); ReadLn(T, n); Assert(1 <= n); Assert(n <= MaxN);
  for i := 1 to n do begin
    Nad[i] := 0; PrviPod[i] := 0; NaslPod[i] := 0; Utajil[i] := 0; Prejel[i] := 0;
  end; {for i}
  Sef := 0; 
  {WriteLn(ParamStr(1));}
  for i := 1 to n do begin
    ReadLn(T, j, Znesek); Assert(0 <= Znesek); 
    {WriteLn(i, ' -> ', j, ' $', Znesek);}
    if j = 0 then begin Assert(Znesek = 0); Assert(Sef = 0); Sef := i end
    else begin Assert(1 <= j); Assert(j <= n); Assert(j <> i);
      Nad[i] := j; NaslPod[i] := PrviPod[j]; PrviPod[j] := i;
      Utajil[i] := Utajil[i] - Znesek;
      Prejel[j] := Prejel[j] + Znesek;
      Utajil[j] := Utajil[j] + Znesek;
    end; {if}
  end; {for i}
  Close(T);
  { Preverimo, da v grafu ni ciklov in da je vse dosegljivo. }
  Assert(Sef <> 0);
  Glava := 1; Rep := Glava + 1; Vrsta[Glava] := Sef;
  while Glava < Rep do begin
    i := Vrsta[Glava]; Glava := Glava + 1;
    j := PrviPod[i];
    while j > 0 do begin
      Assert(Nad[j] = i); 
      Assert(Rep <= n); Vrsta[Rep] := j; Rep := Rep + 1;
      j := NaslPod[j];
    end; {while}
  end; {while}
  Assert(Rep = n + 1);
  { Poiimo najvejo utajo. }
  MaxUtaja := 0;
  {for i := 1 to n do WriteLn(' - ', i, ' je prejel ', Prejel[i], ', utajil ', Utajil[i]);}
  for i := 1 to n do if (i <> Sef) and (Utajil[i] > MaxUtaja) then MaxUtaja := Utajil[i];
  for i := 1 to n do Assert(Prejel[i] <= MaxPrejel);
  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'mafija.out');
  Rewrite(T); WriteLn(T, MaxUtaja); Close(T);
end. {Mafija}
