{$IFDEF NOPE}
{ Tale reitev samo izpie najkraji trajekt, ne pa tudi konkretnega razporeda tovornjakov nanj. }
program Tovornjaki;
const MaxDolzTraj = 100; MaxDolzTov = MaxDolzTraj; MaxStTov = 100;
type 
  TabelaP = ^TabelaT;
  TabelaT = array [0..MaxDolzTraj, 0..MaxDolzTraj, 0..MaxDolzTraj] of boolean;
var d1, d2, d3, Dolzina, StTov, Naj: integer; S, SP, Temp: TabelaP; T: text; B: boolean;
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'tovornjaki.in');
  Reset(T); ReadLn(T, StTov); Assert(1 <= StTov); Assert(StTov <= MaxStTov);
  { }
  New(S); New(SP); 
  for d1 := 0 to MaxDolzTraj do for d2 := 0 to MaxDolzTraj do for d3 := 0 to MaxDolzTraj do S^[d1, d2, d3] := false;
  S^[0, 0, 0] := true;
  { }
  while StTov > 0 do begin
    ReadLn(T, Dolzina); StTov := StTov - 1;
    Assert(1 <= Dolzina); Assert(Dolzina <= MaxDolzTov);
    Temp := S; S := SP; SP := Temp;
    for d1 := 0 to MaxDolzTraj do for d2 := 0 to MaxDolzTraj do for d3 := 0 to MaxDolzTraj do begin
      B := false;
      if d1 >= Dolzina then B := B or SP^[d1 - Dolzina, d2, d3];
      if d2 >= Dolzina then B := B or SP^[d1, d2 - Dolzina, d3];
      if d3 >= Dolzina then B := B or SP^[d1, d2, d3 - Dolzina];
      S^[d1, d2, d3] := B;
    end; {for d3, d2, d1}
  end; {while}
  Close(T);
  { }
  Naj := -1;
  for d1 := 0 to MaxDolzTraj do begin
    for d2 := 0 to d1 do begin
      for d3 := 0 to d2 do begin
        Assert(S^[d1, d2, d3] = S^[d1, d3, d2]);
        Assert(S^[d1, d2, d3] = S^[d2, d1, d3]);
        Assert(S^[d1, d2, d3] = S^[d2, d3, d1]);
        Assert(S^[d1, d2, d3] = S^[d3, d1, d2]);
        Assert(S^[d1, d2, d3] = S^[d3, d2, d1]);
        if S^[d1, d2, d3] then begin Naj := d1; break end;
      end; {for d3}
      if Naj >= 0 then break;
    end; {for d2}
    if Naj >= 0 then break;
  end; {for d1}
  Assert(Naj > 0); 
  Dispose(S); Dispose(SP);  
  { }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'tovornjaki.out');
  Rewrite(T); WriteLn(T, Naj); Close(T);
end. {Tovornjaki}
{$ENDIF}
program Tovornjaki;
const 
  MaxDolzTraj = 100; 
  MaxDolzTov = MaxDolzTraj; 
  MaxStTov = 100;
  MaxDolzTrajBitov = ((MaxDolzTraj + 1) + 7) div 8;
type 
  TabelaP = ^TabelaT;
  TabelaT = packed array [0..MaxStTov, 0..MaxDolzTraj, 0..MaxDolzTraj, 0..MaxDolzTrajBitov - 1] of byte;
var 
  d1, d2, d3, Dolzina, i, n, Naj, B: integer; S: TabelaP; T: text; 
  Dolzine, Pasovi: array [1..MaxStTov] of integer; 
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'tovornjaki.in');
  Reset(T); ReadLn(T, n); Assert(1 <= n); Assert(n <= MaxStTov);
  { }
  New(S); 
  for d1 := 0 to MaxDolzTraj do for d2 := 0 to MaxDolzTraj do for d3 := 0 to MaxDolzTrajBitov - 1 do S^[0, d1, d2, d3] := 0;
  S^[0, 0, 0, 0] := 1;
  { }
  for i := 1 to n do begin
    ReadLn(T, Dolzina); Dolzine[i] := Dolzina;
    Assert(1 <= Dolzina); Assert(Dolzina <= MaxDolzTov);
    for d1 := 0 to MaxDolzTraj do for d2 := 0 to MaxDolzTraj do for d3 := 0 to MaxDolzTraj do begin
      B := 0;
      if d1 >= Dolzina then B := (S^[i - 1, d1 - Dolzina, d2, d3 div 8] shr (d3 mod 8)) and 1;
      if (B = 0) and (d2 >= Dolzina) then B := (S^[i - 1, d1, d2 - Dolzina, d3 div 8] shr (d3 mod 8)) and 1;
      if (B = 0) and (d3 >= Dolzina) then B := (S^[i - 1, d1, d2, (d3 - Dolzina) div 8] shr ((d3 - Dolzina) mod 8)) and 1;
      S^[i, d1, d2, d3 div 8] := (S^[i, d1, d2, d3 div 8] and not (1 shl (d3 mod 8))) or (B shl (d3 mod 8));
    end; {for d3, d2, d1}
  end; {for i}
  Close(T);
  { }
  Naj := -1;
  for d1 := 0 to MaxDolzTraj do begin
    for d2 := 0 to d1 do begin
      for d3 := 0 to d2 do begin
        if ((S^[n, d1, d2, d3 div 8] shr (d3 mod 8)) and 1) = 1 then begin Naj := d1; break end;
      end; {for d3}
      if Naj >= 0 then break;
    end; {for d2}
    if Naj >= 0 then break;
  end; {for d1}
  Assert(Naj > 0); 
  { }
  for i := n downto 1 do begin
    Dolzina := Dolzine[i];
    Assert(((S^[i, d1, d2, d3 div 8] shr (d3 mod 8)) and 1) = 1);
    if d1 >= Dolzina then if ((S^[i - 1, d1 - Dolzina, d2, d3 div 8] shr (d3 mod 8)) and 1) = 1 then begin Pasovi[i] := 1; d1 := d1 - Dolzina; continue end;
    if d2 >= Dolzina then if ((S^[i - 1, d1, d2 - Dolzina, d3 div 8] shr (d3 mod 8)) and 1) = 1 then begin Pasovi[i] := 2; d2 := d2 - Dolzina; continue end;
    if d3 >= Dolzina then if ((S^[i - 1, d1, d2, (d3 - Dolzina) div 8] shr ((d3 - Dolzina) mod 8)) and 1) = 1 then begin Pasovi[i] := 3; d3 := d3 - Dolzina; continue end;
    Assert(false);
  end; {for i}
  Assert(d1 = 0); Assert(d2 = 0); Assert(d3 = 0);
  Dispose(S); 
  { }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'tovornjaki.out');
  Rewrite(T); WriteLn(T, Naj); 
  for i := 1 to n do WriteLn(T, Pasovi[i]);
  Close(T);
end. {Tovornjaki}
