program Tovornjaki;
const 
  MaxDolzTraj = 100; 
  MaxDolzTov = MaxDolzTraj; 
  MaxStTov = 100;
type 
  TabelaP = ^TabelaT;
  TabelaT = packed array [0..MaxDolzTraj, 0..MaxDolzTraj, 0..MaxDolzTraj] of integer;
var 
  n: integer;
  StTov, KjeZadnji: TabelaP; 
  Dolzine: array [1..MaxStTov] of integer; 
  
  procedure Razvij(d1, d2, d3, k, p: integer);
  var d: integer;
  begin
    if (d1 > MaxDolzTraj) or (d2 > MaxDolzTraj) or (d3 > MaxDolzTraj) then exit;
    Assert((StTov^[d1, d2, d3] = k) or (StTov^[d1, d2, d3] = -1));
    if StTov^[d1, d2, d3] >= k then exit;
    StTov^[d1, d2, d3] := k; KjeZadnji^[d1, d2, d3] := p;
    if k < n then begin
      d := Dolzine[k + 1];
      Razvij(d1 + d, d2, d3, k + 1, 1);
      Razvij(d1, d2 + d, d3, k + 1, 2);
      Razvij(d1, d2, d3 + d, k + 1, 3);
    end; {if}
  end; {Razvij}
  
  procedure NajdiResitev(var d1, d2, d3: integer);
  var i1, i2, i3: integer;
  begin
    for i1 := 0 to MaxDolzTraj do for i2 := 0 to i1 do for i3 := 0 to i2 do
      if StTov^[i1, i2, i3] = n then begin d1 := i1; d2 := i2; d3 := i3; exit end;
    Assert(false);
  end; {NajdiResitev}
  
var d1, d2, d3, i, r, Dolzina: integer; Pasovi: array [1..MaxStTov] of integer; T: text; 
begin
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'tovornjaki.in');
  Reset(T); ReadLn(T, n); Assert(1 <= n); Assert(n <= MaxStTov);
  { }
  New(StTov); New(KjeZadnji);
  for d1 := 0 to MaxDolzTraj do for d2 := 0 to MaxDolzTraj do for d3 := 0 to MaxDolzTraj do StTov^[d1, d2, d3] := -1; 
  { }
  for i := 1 to n do begin
    ReadLn(T, Dolzina); Dolzine[i] := Dolzina;
    Assert(1 <= Dolzina); Assert(Dolzina <= MaxDolzTov);
  end; {for i}
  Close(T);
  { }
  Razvij(0, 0, 0, 0, 0);
  NajdiResitev(d1, d2, d3);
  r := d1; if d2 > r then r := d2; if d3 > r then r := d3;
  for i := n downto 1 do begin
    Pasovi[i] := KjeZadnji^[d1, d2, d3]; 
    if Pasovi[i] = 1 then d1 := d1 - Dolzine[i]
    else if Pasovi[i] = 2 then d2 := d2 - Dolzine[i]
    else if Pasovi[i] = 3 then d3 := d3 - Dolzine[i]
    else Assert(false);
  end; {for i}
  { }
  Dispose(StTov); Dispose(KjeZadnji);
  { }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'tovornjaki.out');
  Rewrite(T); WriteLn(T, r); 
  for i := 1 to n do WriteLn(T, Pasovi[i]);
  Close(T);
end. {Tovornjaki}
